; V1.00
;
; To compile use:
;
; AS80 [1.31] - Assembler for 8080/8085/Z80 microprocessor.
;
; Available from:
;   - http://www.falstaff.demon.co.uk/cross.html
;   - ftp://ftp.simtel.net/pub/simtelnet/msdos/crossasm/as80_131.zip
;   - and many Simtel mirrors.
;
; as80 -i -l -n -x2 -v mz-1r12.asm



LETNL   EQU     $0006
PRNT    EQU     $0012
MSG     EQU     $0015
GETKY   EQU     $001B
RDINF   EQU     $0027
RDDAT   EQU     $002A
ST1     EQU     $00AD
QNL     EQU     $0918

NAME    EQU     $10F1
SIZE    EQU     $1102
DTADR   EQU     $1104
COMNT   EQU     $1108


        ORG $E800


MZ1R12:
        NOP
        LD      A,$16
        CALL    PRNT
        CALL    LETNL
        CALL    LETNL
ST1X:
        CALL    LETNL
        CALL    LETNL
        LD      DE,LE83B        ; 'PRESS R, W OR M'
        CALL    MSG
        CALL    LETNL
        CALL    LETNL
        LD      DE,LE85B        ; 'R: READ   S-RAM'
        CALL    MSG
        CALL    LETNL
        LD      DE,LE877        ; 'W: WRITE  S-RAM'
        CALL    MSG
        CALL    LETNL
        LD      DE,LE893        ; 'M: MONITOR'
        CALL    MSG
        CALL    LETNL
        JR      LE8AB


LE83B:  DB      '           P',$05,'RESS',$05,' R , W ',$05,'OR',$05,' M',$0D
LE85B:  DB      '            R:',$05,'READ',$05,'  S-RAM',$0D
LE877:  DB      '            W:',$05,'WRITE',$05,' S-RAM',$0D
LE893:  DB      '            M:',$05,'MONITOR',$05,$0D


LE8AB:
        NOP
        CALL    GETKY
        CP      'M'
        JP      Z,MON
        CP      'W'
        JP      Z,LE96A
        CP      'R'
        JP      Z,LE8C1
        JP      NZ,LE8AB

LE8C1:
        NOP
        LD      A,$16
        CALL    PRNT
        CALL    LETNL
        CALL    LETNL
        CALL    LETNL
        LD      DE,LEB1B        ; 'LOADING PROGRAM FROM S-RAM'
        CALL    MSG
        CALL    LETNL
        CALL    LETNL
        CALL    CHECK
        IN      A,($F8)         ; Counter reset
        IN      A,($F9)
        LD      C,A
        IN      A,($F9)
        LD      B,A
        IN      A,($F9)
        LD      L,A
        IN      A,($F9)
        LD      H,A
        IN      A,($F9)
        LD      E,A
        IN      A,($F9)
        LD      D,A
        PUSH    DE
        LD      D,B
        LD      E,C
        IN      A,($F9)
        LD      C,A
        IN      A,($F9)
        LD      B,A
        IN      A,($F9)
        PUSH    BC
        PUSH    DE
        PUSH    HL
        LD      C,$F9
        LD      A,E
        OR      A
        JR      Z,LE90A
        LD      B,A
LE908:
        INIR
LE90A:
        LD      B,$00
        DEC     D
        JP      P,LE908
        POP     DE              ; Data adr
        POP     BC              ; Size
        CALL    SUM
        POP     DE
        OR      A
        SBC     HL,DE
        JR      NZ,LE956
        POP     HL
        JP      (HL)


;
;       sum check
;
; IN BC=Size
;    DE=Data adr
; EXIT HL=Check sum
;
SUM:
        PUSH    BC
        PUSH    DE
        EXX
        LD      HL,$0000        ; HL'= Check sum clr
        LD      C,$08           ; C' = Loop count
        EXX
SUMCK1:
        LD      A,B             ; BC = Size
        OR      C
        JR      Z,SUMCK2
        LD      A,(DE)          ; DE = Data adrs
        EXX
        LD      B,C             ; BC'
SUMCK3:
        RLCA
        JR      NC,LE931
        INC     HL              ; HL' = Check sum data
LE931:
        DJNZ    SUMCK3
        EXX
        INC     DE              ; DE
        DEC     BC              ; BC
        JP      SUMCK1
SUMCK2:
        EXX
        POP     DE
        POP     BC
        RET



;
;       Information's sum check
;
CHECK:
        IN      A,($F8)         ; Counter reset
        LD      BC,$0800        ; B=Byte Counter C=Sum Counter
CK1:
        IN      A,($F9)         ; Counter=Counter+1
        PUSH    BC
        LD      B,$08           ; Bit Counter
CK2:
        RLCA
        JR      NC,LE94B
        INC     C
LE94B:
        DJNZ    CK2
        LD      A,C
        POP     BC
        LD      C,A
        DJNZ    CK1
        IN      A,($F9)
        CP      C
        RET


LE956:
        LD      A,$16
        CALL    PRNT
        CALL    LETNL
        CALL    LETNL
        LD      DE,LEA8F        ; 'CHECK SUM ERROR'
        CALL    LEA3D
        JP      ST1X

LE96A:
        LD      A,$16
        CALL    PRNT
        CALL    LETNL
        CALL    LETNL
        CALL    LETNL
        LD      DE,LEAAC        ; 'S-RAM PROGRAMMING'
        CALL    LEA36
        LD      DE,LEACB        ; 'SET MASTER TAPE  PLAY'
        LD      A,$11
        LD      HL,$D8F0
        CALL    LEA4A
        CALL    LETNL
        CALL    LEA39
        CALL    RDINF
        PUSH    AF
        PUSH    BC
        LD      BC,(SIZE)
        LD      A,$7F
        CP      B
        JR      C,LE9A8
        JR      NZ,LE9A4
        LD      A,$F6
        CP      C
        JR      C,LE9A8
LE9A4:
        POP     BC
        POP     AF
        JR      LE9AD
LE9A8:
        POP     BC
        POP     AF
        JP      LEA74

LE9AD:
        LD      A,$00
        LD      HL,$D0F0
        CALL    LEA4A
        LD      A,$71
        LD      HL,$D8F0
        CALL    LEA4A
        LD      A,$02
        JP      C,LEA42
        CALL    LETNL
        LD      DE,LEAF1        ; 'FOUND : '
        CALL    LEA3D
        LD      DE,NAME
        PUSH    DE
        RST     $18
        CALL    LETNL
        LD      DE,LEB06        ; 'LOADING : '
        CALL    LEA3D
        POP     DE
        RST     $18
;
;       Read data block
;
        CALL    RDDAT
        JR      C,LEA42
;
;       Counter reset
;
        IN      A,($F8)
;
;       Sum check for data
;
        LD      DE,(DTADR)
        LD      BC,(SIZE)
        PUSH    DE
        PUSH    BC
        CALL    SUM
        LD      (COMNT),HL
;
;       Write information (8Byte)
;
        LD      HL,SIZE
        LD      BC,$08FA        ; B=Byte Counter
        PUSH    HL
        PUSH    BC
        OTIR
        POP     BC
        POP     HL
;
;       Sum check for information block
;           AccCheck sum data
;
        PUSH    DE              ; DE Size
        LD      D,$00           ; Sum Counter
WCK1:
        PUSH    BC
        LD      B,$08
        LD      A,(HL)
WCK2:
        RLCA
        JR      NC,WCK3
        INC     D
WCK3:
        DJNZ    WCK2
        INC     HL
        POP     BC
        DJNZ    WCK1
        LD      A,D
        POP     DE
        OUT     ($FA),A
;
;       Write data block
;
        POP     DE              ; DE Size
        POP     HL              ; HL Data adrs
        LD      A,E
        OR      A
        JR      Z,LEA1C
        LD      B,E
LEA1A:
        OTIR
LEA1C:
        LD      B,$00
        DEC     D
        JP      P,LEA1A
        LD      A,$16
        CALL    PRNT
        CALL    LETNL
        CALL    LETNL
        LD      DE,LEB8C        ; 'WRITING S-RAM O.K.!'
        CALL    MSG
        JP      ST1X


LEA36:
        CALL    QNL
LEA39:
        RST     $18
        JP      QNL

LEA3D:
        CALL    QNL
        RST     $18
        RET

LEA42:
        CP      $02
        JP      Z,LEA60
        JP      LE956

LEA4A:
        LD      B,$06
LEA4C:
        LD      (HL),A
        INC     HL
        DEC     B
        JR      NZ,LEA4C
        RET

MON:
        LD      A,$16
        CALL    PRNT
        LD      DE,LEB3E        ; '** MONITOR 1Z-009A **'
        CALL    MSG
        JP      ST1

LEA60:
        LD      A,$16
        CALL    PRNT
        CALL    LETNL
        CALL    LETNL
        LD      DE,LEB77        ; 'BREAK !'
        CALL    MSG
        JP      ST1X

LEA74:
        LD      DE,$0000
        LD      (SIZE),DE
        LD      A,$16
        CALL    PRNT
        CALL    LETNL
        CALL    LETNL
        LD      DE,LEBAD        ; 'FILE IS TOO LONG'
        CALL    MSG
        JP      ST1X


LEA8F:  DB      '           C',$05,'HECK SUM ERROR',$05,$0D
LEAAC:  DB      '           S-RAM ',$05,'PROGRAMMING',$05,$0D
LEACB:  DB      '        S',$05,'ET MASTER TAPE',$05,'   ',$7F,'P',$05,'LAY',$05,'  ',$0D
LEAF1:  DB      '         F',$05,'OUND',$05,'  : ',$0D
LEB06:  DB      '         L',$05,'OADING',$05,': ',$0D
LEB1B:  DB      '      L',$05,'OADING PROGRAM FROM ',$05,'S-RAM',$0D
LEB3E:  DB      '**  MONITOR 1Z-009A  **',$0D
LEB56:  DB      '           R',$05,'EADING',$05,' S-RAM O.K.!',$0D
LEB77:  DB      '           B',$05,'REAK',$05,' !',$0D
LEB8C:  DB      '           W',$05,'RITING',$05,' S-RAM O.K.!',$0D
LEBAD:  DB      '           F',$05,'ILE IS TOO LONG',$05,$0D

; the following is only to get the original length of 4096 bytes

        ORG     $F7FF
        DB      $FF
